# Starts the datapack's recurring functions
function healthysleep:schedules/list

### These lines add tracking capability for various values:

# isSleeping will = 0 when a player is sleeping. Value will increase by 1 every game tick a player is NOT sleeping.
# timeOfDay is used to track the current time of day.
# timePrevious is used to store what the time of day it was 5 server ticks ago. Used to calculate if there is time acceleration (from mods/plugins).
# timeDifference is used to store the difference between timeOfDay and timePrevious. Used to calculate added sleepScore when sleeping.
# timeFix is a constant (24000) used to correct when timeDifference is negative
# sleepScore is used to track how long players have slept in in-world time. Can be negative to represent sleep deficit.
# sleepDeficitScore is a secondary sleep score used to fix excessive sleep deficit.
# alarmClock is used to make the alarm clock feature
# timeInBed is the time in server ticks that a player has been in a bed.
# timeSlept is how much MC time a player has slept, independent of their sleepScore.
# wellrested tracks if a player has slept long enough to receive a buff.
# wellrestedCooldown is used to verify that a player isn't receiving the wellrested buff too often.
# overslept tracks if a player has slept too long and receives a debuff.

scoreboard objectives add isSleeping minecraft.custom:minecraft.time_since_rest
scoreboard objectives add timeOfDay dummy
scoreboard objectives add timePrevious dummy
scoreboard objectives add timeDifference dummy
scoreboard objectives add timeFix dummy
scoreboard objectives add sleepScore dummy
scoreboard objectives add sleepDeficitScore dummy
scoreboard objectives add alarmClock dummy
scoreboard objectives add timeInBed dummy
scoreboard objectives add timeSlept dummy
scoreboard objectives add wellrested dummy
scoreboard objectives add wellrestedCooldown dummy
scoreboard objectives add overslept dummy
scoreboard objectives add healed dummy


# Reset of certain trackers in the event of a reload.
scoreboard players set fp_HealthySleep timeFix 24000
scoreboard players set @a wellrested 0
scoreboard players set @a wellrestedCooldown 1
scoreboard players set @a overslept 0
scoreboard players set @a healed 0


# Debug: Message to verify the Datapack has loaded and should be functioning.
tellraw @a ["",{"text":"HealthySleep v4-1.21.x has loaded.","italic":true,"color":"green"},{"text":" Sleep well!","italic":true,"color":"gray"}]

# Debug: Displays a tracked value in sidebar.
# scoreboard objectives setdisplay sidebar sleepScore
