### SLEEP HEALING
# Check if players are eligible for sleep healing by resetting markers for awake players
execute at @a[scores={healed=1,timeSlept=0}] run scoreboard players set @p healed 0

# Apply heal1 to waking players if they slept 4 minecraft hours
execute at @a[scores={healed=0,isSleeping=1..41,timeSlept=4000..5999}] run function healthysleep:sleepeffects/heal1

# Apply heal2 to waking players if they slept 6 minecraft hours
execute at @a[scores={healed=0,isSleeping=1..41,timeSlept=6000..7999}] run function healthysleep:sleepeffects/heal2

# Apply heal3 to waking players if they slept 8 minecraft hours
execute at @a[scores={healed=0,isSleeping=1..41,timeSlept=8000..}] run function healthysleep:sleepeffects/heal3


### WELL RESTED AND OVERSLEPT

# If a player has slept at least 2 minecraft hours and has a sleepScore over the threshold, mark them as overslept
execute at @a[scores={timeSlept=2000..}] if score @p sleepScore matches 13000.. run scoreboard players set @p overslept 1

# If a player's sleepScore is below the threshold, remove the wellrestedCooldown marker
execute at @a if score @p sleepScore matches ..2000 run scoreboard players set @p wellrestedCooldown 0

# If a player's sleepScore is below the threshold, remove the overslept marker
execute at @a if score @p sleepScore matches ..13000 run scoreboard players set @p overslept 0

# If the player's sleepScore is higher than the threshold and they don't have a wellrestedCooldown marker, mark them as wellrested
execute at @a[scores={wellrestedCooldown=0}] if score @p sleepScore matches 10000.. run scoreboard players set @p wellrested 1

# Apply debuffoversleeping to sleeping players if they have the overslept marker
execute at @a[scores={isSleeping=0,overslept=1}] run function healthysleep:sleepeffects/debuffoversleeping

# Apply debuffoverslept to waking players if they have the overslept marker
execute at @a[scores={isSleeping=21..41,overslept=1}] run function healthysleep:sleepeffects/debuffoverslept

# Apply buffwellrested to waking players if they have the wellrested marker
execute at @a[scores={isSleeping=21..41,wellrested=1}] run function healthysleep:sleepeffects/buffwellrested

# Loop function
schedule function healthysleep:schedules/sleepeffectcheck 20t
