# Limit sleepScore to 14000
execute at @a if score @p sleepScore matches 14001.. run scoreboard players set @p sleepScore 14000

# Track how long a player has been in a bed
execute at @a[scores={isSleeping=0}] run scoreboard players add @p timeInBed 10
execute at @a[scores={isSleeping=1..}] run scoreboard players set @p timeInBed 0

# If a player tries to sleep when their sleepScore is too high they will be kicked out of bed and told they cant sleep
execute at @a[scores={isSleeping=0,timeInBed=..10,sleepScore=12000..}] run function healthysleep:systems/cantsleep

# When a player is sleeping and they have a sleep deficit, add to their sleepDeficitScore an amount equal to minecraft time passed
execute at @a[scores={isSleeping=0..21,sleepScore=..-1}] run scoreboard players operation @p sleepDeficitScore += fp_HealthySleep timeDifference

# When a player's sleepDeficitScore reaches 4 minecraft hours worth, remove their sleep deficit
execute at @a[scores={sleepScore=..-3001}] run execute at @a if score @p sleepDeficitScore matches 4000.. run scoreboard players set @p sleepScore -3000

# If a player is not sleeping, reset their sleepDeficitScore to 0
execute at @a[scores={isSleeping=41..}] run scoreboard players set @p sleepDeficitScore 0

# Players in Survival or Adventure mode who have been awake for 60s will start to lose their sleepScore over time inducing sleep deficit when negative
# This mechanic is tied to real-time to avoid rapidly punishing players who were awake during time acceleration.
execute at @a[gamemode=!creative,gamemode=!spectator] if score @p isSleeping matches 1200.. run scoreboard players remove @p sleepScore 10

# Players who are sleeping will add to their sleepScore an amount equal to the minecraft time passed
execute at @a[scores={isSleeping=0..20}] run scoreboard players operation @p sleepScore += fp_HealthySleep timeDifference

# Players who are sleeping will add to their timeSlept an amount equal to the minecraft time passed
execute at @a[scores={isSleeping=0..20}] run scoreboard players operation @p timeSlept += fp_HealthySleep timeDifference

# If a player is not sleeping, reset their timeSlept to 0
execute at @a[scores={isSleeping=42..}] run scoreboard players set @p timeSlept 0

# If a player has been sleeping 3 seconds, give them the alarmClock marker
execute at @a[scores={isSleeping=0,timeInBed=60..80}] run scoreboard players set @p alarmClock 1

# If a sleeping player's sleepScore is within the range, and they have the alarmClock marker, activate alarmClock
execute at @a[scores={isSleeping=0,alarmClock=1}] run execute at @p if score @p sleepScore matches 10000..12000 run function healthysleep:systems/alarmclock

# If a player's sleep score hits 2000, notify them that they are tired, and therefore their wellrestedCooldown is gone
execute at @a if score @p sleepScore matches 2000 run tellraw @p {"text":"I'm pretty tired...","italic":true,"color":"gray"}

# Loop function
schedule function healthysleep:schedules/sleeptracking 10t
